#include <stdio.h>

unsigned char buffer[1024 * 16 * 154];


static
int getlong(unsigned char* p)
{
	return (p[0] << 24) + (p[1] << 16) + (p[2] << 8) + p[3];
}

int main(int argc, char *argv[])
{
	int ret = 1;

	int i;

	FILE *fp;

	if (argc != 2) {
		fprintf(stderr, "tmilfile <disk image>\n");
		return ret;
	}

	fp = fopen(argv[1], "rb");
	if (fp == NULL) {
		fprintf(stderr, "can't open %s\n", argv[1]);
		return ret;
	}

	fread(buffer, sizeof(unsigned char), sizeof(buffer), fp);
	fclose(fp);

	fp = fopen("main.x", "wb");
	fwrite(&buffer[0x3000], sizeof(char), 0x9800, fp);
	fclose(fp);

	unsigned char* dirbuf = &buffer[0x2c00];
	for (i = 0; i < 0x400 / 4 - 1; i++)
	{
		int pos;
		int next;
		char fname[32];

		pos  = getlong(&dirbuf[i * 4]);
		next = getlong(&dirbuf[i * 4 + 4]);

		if (pos == next) continue;
		if (next < pos) break;

		sprintf(fname, "%02x.bin", i);

		printf("%s\n", fname);

		fp = fopen(fname, "wb");
		fwrite(&buffer[pos], sizeof(char), next - pos, fp);
		fclose(fp);
	}

	ret = 0;

	return ret;
}

